import { Coordinates } from "../Common.types";
import { GeometryVector } from "../geometry/Vector.types";
export interface Vertex {
    id: () => number | string;
    positionGetter: () => Coordinates;
    positionSetter: () => boolean;
    position: (obj?: Coordinates) => void | Coordinates;
    x: (value?: number) => number;
    y: (value?: number) => number;
    vector: () => GeometryVector;
    visible: (value?: boolean) => void | boolean;
    generated: () => boolean;
    updated: () => boolean;
    type: () => string;
    edgeSets: () => any;
    edgeSetCollections: () => any;
    edges: () => any;
    connectedVerticies: () => Vertex[];
    graph: () => any;
    parentVertexSet: () => any;
    rootVertexSet: () => any;
    generatedRootVertexSet: () => any;
    selected: () => boolean;
    set: (key: string, value: any) => void;
    get: (key: string) => any;
    has: (name: string) => boolean;
    getData: () => any;
    addEdgeSet: (edgeSet: any, linkKey: string) => void;
    removeEdgeSet: (linkKey: string) => void;
    addEdgeSetCollection: (esc: any, linkKey: string) => void;
    eachConnectedVertex: (callback: any, context: any) => void;
    translate: (Coordinates: any) => void;
}
